import win32com.client
from pathlib import Path
import os

FOLDER = 'C:\\python_distr\\'
file = '0923_Каналы_продаж.xlsx'
fn = f'{FOLDER}{file}'


# Open Microsoft Excel
excel = win32com.client.DispatchEx("Excel.Application")
excel.DisplayAlerts = False

def create_distributor_file(file_name, work_dir, list_name, distr_name, app):
    wb = app.Workbooks.Open(fn)
    ws = wb.Worksheets(list_name)    
    ws.Cells(2, 1).Value = distr_name
    app.CalculateUntilAsyncQueriesDone()    
    wb.SaveAs(Filename=f'{FOLDER}{distr_name}_{file}')
    wb.Close()


def refresh_file(file_name, app):
    wb = app.Workbooks.Open(file_name)
    wb.RefreshAll()
    app.CalculateUntilAsyncQueriesDone()
    wb.Save()
    

for distr_name in ['Дистрибутор Альметьевск-Бугульма', 'Дистрибутор Оренбург',
                   'Дистрибутор Самара', 'Дистрибутор Саранск',
                   'Дистрибутор Саратов', 'Дистрибутор Тольятти',
                   'Дистрибутор Ульяновск', 'Дистрибутор Чебоксары',]:    
    create_distributor_file(file_name=fn,
                             work_dir=FOLDER,
                             list_name='data',
                             distr_name=distr_name,
                             app=excel)


os.remove(r'C:\python_distr\0923_Каналы_продаж.xlsx')

directory = r'C:\python_distr'

pathlist = Path(directory).glob('*.xlsx')

for path in pathlist:
    refresh_file(file_name=path, app=excel)
    
excel.Quit()
